/* Copyright (c) Sun Microsystems 2006. All rights reserved.
   This file is part of OpenOffice.org project.
   
   Written by Ramón García Fernández <ramon.garcia.f+openoffice@gmail.com>.
   This work was supported by a Google Summer of Code grant.
*/

/* Interface for showing output in multiple programming languages */

#ifndef OB_BROWSER_LANG_H
#define OB_BROWSER_LANG_H

#include "objectbrowser_impl.hxx"

#include <com/sun/star/beans/Property.hpp>
#include <com/sun/star/reflection/XIdlField.hpp>

namespace objectbrowser_impl {
    using com::sun::star::beans::Property;
    using com::sun::star::reflection::XIdlField;
class BrowserLang {
public:
    /* Write the declaration of a method */
    virtual SvLBoxEntry* insertMethod(SvTreeListBox& t, SvLBoxEntry* parent, const Reference<XIdlMethod>& m) const = 0;
    
    /* Write the declaration of a property */
    virtual SvLBoxEntry* insertProperty(SvTreeListBox& t, SvLBoxEntry* parent, const Property& p) const = 0;

    /* Write the declaration of an attribute */
    virtual SvLBoxEntry* insertAttribute(SvTreeListBox& t, SvLBoxEntry* parent, const Reference<XIdlField> & p) const = 0;

};

/* Array of programming languages */
extern const BrowserLang* langs[2];

}
#endif
