#ifndef FIELD_DATA_HXX
#define FIELD_DATA_HXX

#include <rtl/ustring.hxx>
#include <svtools/svlbox.hxx>

#define FIELD_DATA_ITEM_ID 0xBEEF


using rtl::OUString;


class FieldData: public SvLBoxItem {
    OUString interface;
    OUString field_name;
    BOOL in_flat_list;
    void* od;
public:
    USHORT IsA();
    void Paint( const Point& rPos, SvLBox& rOutDev,
		USHORT nViewDataEntryFlags,
		SvLBoxEntry* pEntry );
    void InitViewData( SvLBox* pView, SvLBoxEntry* pEntry, SvViewDataItem* pViewData = 0);
    SvLBoxItem* Create() const;
    void Clone(SvLBoxItem* pSource );

    OUString GetURL() const;
    BOOL InFlatList() const { return in_flat_list; }
    void* GetObjectData() { return od; }
    OUString& GetInterface() { return interface; }
    FieldData(const OUString& interface, const OUString& field_name, void* od, BOOL in_flat_list) : 
	interface(interface), field_name(field_name), od(od), in_flat_list(in_flat_list)  {}
};



#endif
