#include <com/sun/star/uno/Reference.hxx>
#include <com/sun/star/uno/Sequence.hxx>
#include <com/sun/star/frame/XDesktop.hpp>
#include <com/sun/star/frame/XDispatchProvider.hpp>
#include <com/sun/star/frame/XDispatch.hpp>
#include <com/sun/star/util/XURLTransformer.hpp>
#include <com/sun/star/util/URL.hpp>
#include <com/sun/star/beans/PropertyValue.hpp>

using namespace com::sun::star::uno;
using namespace com::sun::star::frame;
using namespace com::sun::star::util;
using namespace com::sun::star::beans;

#include "create_instance.hxx"

#include "url.hxx"

namespace objectbrowser_impl {

void OpenURL(const Reference<XComponentContext>& c, const OUString& url)
{
    Reference<XDesktop> desktop = createInstance<XDesktop>(c, "com.sun.star.frame.Desktop");
    Reference<XDispatchProvider> dispatch_provider(desktop, com::sun::star::uno::UNO_QUERY);
    URL openLinkCmd;
    Reference<XURLTransformer> url_prep = createInstance<XURLTransformer>(c, "com.sun.star.util.URLTransformer");
    openLinkCmd.Complete = OUString(RTL_CONSTASCII_USTRINGPARAM(".uno:OpenHyperlink"));
    url_prep->parseStrict(openLinkCmd);
    Reference<XDispatch> dispatch = dispatch_provider->queryDispatch(openLinkCmd, OUString(), 0);
    Sequence<PropertyValue > args(1);
    args[0].Name = OUString(RTL_CONSTASCII_USTRINGPARAM("URL"));
    args[0].Value <<= url;
    dispatch->dispatch(openLinkCmd, args);
}

}
